#include <bits/stdc++.h>
#define db long double

using namespace std;

random_device rd;
mt19937 gen(rd());

struct zxc{
    db a, b, c;
};

zxc def_str(db x1, db y1, db x2, db y2) {
    db a = y2 - y1, b = x1 - x2, c = -a * x1 - b * y1;
    return {a, b, c};
}

db dist(db x1, db y1, db x2, db y2) {
    return sqrt(pow(x1 - x2, 2) + pow(y1 - y2, 2));
}

pair<db, db> prs(zxc a, zxc b) {
    db x = (b.c * a.b - a.c * b.b) / (a.a * b.b - b.a * a.b), y = (b.c * a.a - a.c * b.a) / (a.b * b.a - b.b * a.a);
    return {x, y};
}

int f(int x) {
    if (x == 1) return 1;
    return x * f(x - 1);
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n;

    vector<pair<db, db>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;

    vector<pair<int, int>> v;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;

            db x = a[i].first - a[j].first, y = a[i].second - a[j].second;
            v.emplace_back(x, y);
        }
    }

    db ans = 2e18;
    for (auto [x, y] : v) {
        vector<pair<zxc, zxc>> p(n);

        for (int i = 0; i < n; ++i) {
            p[i] = {def_str(a[i].first, a[i].second, a[i].first + x, a[i].second + y), def_str(a[i].first, a[i].second, a[i].first + y, a[i].second - x)};
        }

        vector<vector<db>> vert(n, vector<db>(n));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j) continue;

                auto [x1, y1] = prs(p[i].first, p[j].second);
                vert[i][j] = dist(a[i].first, a[i].second, x1, y1) + dist(a[j].first, a[j].second, x1, y1);
            }
        }


        vector<int> pr;
        for (int i = 0; i < n; ++i) pr.push_back(i);

        for (int t = 0; t < f(n); ++t) {
            db cur = 0;

            for (int i = 1; i < n; ++i) {
                cur += vert[pr[i - 1]][pr[i]];
            }

            if (ans > cur) {
                ans = cur;
            }

            next_permutation(pr.begin(), pr.end());
        }
    }

    cout << fixed << setprecision(9) << ans;
}